# IotCentral

> see https://aka.ms/autorest

This is the AutoRest configuration file for IotCentral.

---
## Getting Started
To build the SDK for IotCentral, simply [Install AutoRest](https://aka.ms/autorest/install) and in this folder, run:

> `autorest`

To see additional help and options, run:

> `autorest --help`
---

## Configuration



### Basic Information
These are the global settings for IotCentral.

``` yaml
openapi-type: arm
tag: package-2017-07-01-privatepreview
```


### Tag: package-2017-07-01-privatepreview

These settings apply only when `--tag=package-2017-07-01-privatepreview` is specified on the command line.

``` yaml $(tag) == 'package-2017-07-01-privatepreview'
input-file:
- Microsoft.IoTCentral/preview/2017-07-01-privatepreview/iotcentral.json
```

---
# Code Generation

## Swagger to SDK

This section describes what SDK should be generated by the automatic system.
This is not used by Autorest itself.

``` yaml $(swagger-to-sdk)
swagger-to-sdk:
  - repo: azure-sdk-for-python
  - repo: azure-sdk-for-java
  - repo: azure-sdk-for-go
  - repo: azure-sdk-for-node
  - repo: azure-sdk-for-ruby
    after_scripts:
      - bundle install && rake arm:regen_all_profiles['azure_mgmt_iot_central']
```

## C#

These settings apply only when `--csharp` is specified on the command line.
Please also specify `--csharp-sdks-folder=<path to "SDKs" directory of your azure-sdk-for-net clone>`.

``` yaml $(csharp)
csharp:
  azure-arm: true
  license-header: MICROSOFT_MIT_NO_VERSION
  namespace: Microsoft.Azure.Management.IotCentral
  payload-flattening-threshold: 1
  output-folder: $(csharp-sdks-folder)/IotCentral/Management.IotCentral/Generated
  clear-output-folder: true
```

## Go

These settings apply only when `--go` is specified on the command line.

``` yaml $(go)
go:
  license-header: MICROSOFT_APACHE_NO_VERSION
  clear-output-folder: true
  namespace: iotcentral
```

### Go multi-api

``` yaml $(go) && $(multiapi)
batch:
  - tag: package-2017-07-01-privatepreview
```

### Tag: package-2017-07-01-privatepreview and go

These settings apply only when `--tag=package-2017-07-01-privatepreview --go` is specified on the command line.
Please also specify `--go-sdk-folder=<path to the root directory of your azure-sdk-for-go clone>`.

``` yaml $(tag)=='package-2017-07-01-privatepreview' && $(go)
output-folder: $(go-sdk-folder)/services/preview/$(namespace)/mgmt/2017-07-01-privatepreview/$(namespace)
```

## Java

These settings apply only when `--java` is specified on the command line.
Please also specify `--azure-libraries-for-java-folder=<path to the root directory of your azure-libraries-for-java clone>`.

``` yaml $(java)
azure-arm: true
fluent: true
namespace: com.microsoft.azure.management.iotcentral
license-header: MICROSOFT_MIT_NO_CODEGEN
payload-flattening-threshold: 1
output-folder: $(azure-libraries-for-java-folder)/azure-mgmt-iotcentral
```

### Java multi-api

``` yaml $(java) && $(multiapi)
batch:
  - tag: package-2017-07-01-privatepreview
```

### Tag: package-2017-07-01-privatepreview and java

These settings apply only when `--tag=package-2017-07-01-privatepreview --java` is specified on the command line.
Please also specify `--azure-libraries-for-java-folder=<path to the root directory of your azure-sdk-for-java clone>`.

``` yaml $(tag)=='package-2017-07-01-privatepreview' && $(java) && $(multiapi)
java:
  namespace: com.microsoft.azure.management.iotcentral.v2017_07_01_privatepreview
  output-folder: $(azure-libraries-for-java-folder)/iotcentral/resource-manager/v2017_07_01_privatepreview
regenerate-manager: true
generate-interface: true
```

## Python

These settings apply only when `--python` is specified on the command line.
Please also specify `--python-sdks-folder=<path to the root directory of your azure-sdk-for-python clone>`.
Use `--python-mode=update` if you already have a setup.py and just want to update the code itself.

``` yaml $(python)
python-mode: create
python:
  azure-arm: true
  license-header: MICROSOFT_MIT_NO_VERSION
  payload-flattening-threshold: 2
  namespace: azure.mgmt.iotcentral
  package-name: azure-mgmt-iotcentral
  clear-output-folder: true
```
``` yaml $(python) && $(python-mode) == 'update'
python:
  no-namespace-folders: true
  output-folder: $(python-sdks-folder)/azure-mgmt-iotcentral/azure/mgmt/iotcentral
```
``` yaml $(python) && $(python-mode) == 'create'
python:
  basic-setup-py: true
  output-folder: $(python-sdks-folder)/azure-mgmt-iotcentral
```
